Description

Browser default title tooltip is quite non friendly for the user and/or UI development. For example, you cannot control the delay and

HTML is not supported. Moving to jQuery UI Tooltip improves the current UI experience and will allow us in the future to make new

improvements.

Regarding my proposed patch, I decided to not add an arrow to the tooltip because I don't think that it worth it.
Related issues:

Related to Redmine - Feature #32029: Replace gantt and calendar tooltips with... New

Related to Redmine - Defect #33250: Useless white box appears over the the to... Closed

Related to Redmine - Defect #34247: Web browser freezes when displaying workf... Closed

Related to Redmine - Defect #34834: Line breaks in the description of a custo... Closed

Associated revisions

Revision 18260 - 2019-06-19 10:30 - Go MAEDA

Show elements titles using jQuery UI tooltips (#31441).

Patch by Marius BALTEANU.

History

#1 - 2019-05-24 12:04 - Go MAEDA

- Target version set to Candidate for next major release

+1 remarkably nice improvement!

#2 - 2019-05-26 09:02 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

Setting the target version to 4.1.0.

#3 - 2019-06-18 04:00 - Mizuki ISHIKAWA

+1

#4 - 2019-06-18 09:34 - Seiei Miyagi

I found the XSS in attached patch.

If I fill the project description like below, then open http://localhost:3000/admin/projects and hover the title of the project, the alert is showing.

<script>alert(1)</script>

 the content function needs to escape the $(this).prop('title')

#5 - 2019-06-18 09:52 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

Seiei Miyagi wrote:
http://localhost:3000/admin/projects


I found the XSS in attached patch.

If I fill the project description like below, then open http://localhost:3000/admin/projects and hover the title of the project, the alert is showing.

[...]

the content function needs to escape the $(this).prop('title')

 You're right, thanks for pointing this out, I'll fix it.

#6 - 2019-06-19 10:01 - Marius BĂLTEANU

- File tooltip_v2.patch added

I think for now it's enough to disable the HTML support (attached patch).

What do you think, Seiei Miyagi?

#7 - 2019-06-19 10:22 - Seiei Miyagi

Thank you! It looks good to me.

Since the title attribute is too general and XSS may occur, I think it would be nice to disable HTML support.

IMO If you need HTML support, it may be better to add explicit attributes. (e.g. like html-safe? IDK)

#8 - 2019-06-19 10:33 - Go MAEDA

- Status changed from New to Closed

- Assignee changed from Marius BĂLTEANU to Go MAEDA

Thank you to everyone who involved in this patch.

#9 - 2019-08-04 23:01 - Marius BĂLTEANU

- File issue_subject_tooltip.png added

- File selectors_for_tooltip.patch added

- Status changed from Closed to Reopened

I've just observed some bad effects of my patch. For example, in the gantt chart, the tooltip is shown even if the issue subject is visible:

 issue_subject_tooltip.png 

I propose to replace the current [title] selector (which is too generic) with:

- a custom attribute data-toggle="tooltip" for enable the tooltip on elements

- '.icon-only' selector to target all the links rendered only as icon

#10 - 2019-08-07 02:19 - Go MAEDA

- File tooltip-for-issues@2x.png added

Marius BALTEANU wrote:

I propose to replace the current [title] selector (which is too generic) with:

- a custom attribute data-toggle="tooltip" for enable the tooltip on elements

- '.icon-only' selector to target all the links rendered only as icon

 Tooltip for issues or some other objects will disappear after applying the new patch. Please see the screenshot below for an example. It is a pity if I

cannot see the useful information any longer.

 

#11 - 2019-08-07 07:52 - Marius BĂLTEANU

Go MAEDA wrote:
http://localhost:3000/admin/projects


Tooltip for issues or some other objects will disappear after applying the new patch. Please see the screenshot below for an example. It is a pity

if I cannot see the useful information any longer.

 You're right, but the plan is to add to all other objects that should have tooltips one by one. I'll update the patch to include the tooltip for object links as

well.

#12 - 2019-08-17 12:26 - Marius BĂLTEANU

Go Maeda, is it better if we remove the title the from gantt issue subject?

Mariuss-MacBook-Pro:redmine mariusbalteanu$ git diff

diff --git a/lib/redmine/helpers/gantt.rb b/lib/redmine/helpers/gantt.rb

index ef9475cea..ed2a8f8f7 100644

--- a/lib/redmine/helpers/gantt.rb

+++ b/lib/redmine/helpers/gantt.rb

@@ -747,7 +747,6 @@ module Redmine

         when Issue

           tag_options[:id] = "issue-#{object.id}" 

           tag_options[:class] = "issue-subject hascontextmenu" 

-          tag_options[:title] = object.subject

           children = object.children & project_issues(object.project)

           has_children = children.present? && (children.collect(&:fixed_version).uniq & [object.fixed_version

]).present?

         when Version

#13 - 2019-08-18 06:04 - Go MAEDA

Marius BALTEANU wrote:

Go Maeda, is it better if we remove the title the from gantt issue subject?

 I agree.

But I would like to suggest another option. How about setting "Assignee (Status)" instead of removing the subject? The assignee and status are

important information but those are not prominent in gantt.

Marius, which do you prefer?

diff --git a/lib/redmine/helpers/gantt.rb b/lib/redmine/helpers/gantt.rb

index ef9475cea..cc5b97cd7 100644

--- a/lib/redmine/helpers/gantt.rb

+++ b/lib/redmine/helpers/gantt.rb

@@ -747,7 +747,7 @@ module Redmine

         when Issue

           tag_options[:id] = "issue-#{object.id}" 

           tag_options[:class] = "issue-subject hascontextmenu" 

-          tag_options[:title] = object.subject

+          tag_options[:title] = "#{object.assigned_to&.name} (#{object.status.name})".lstrip

           children = object.children & project_issues(object.project)

           has_children = children.present? && (children.collect(&:fixed_version).uniq & [object.fixed_version

]).present?

         when Version

#14 - 2019-09-06 16:56 - Anonymous

- File gantttooltip.png added

I think tool-tips like these should also be used as gantt tool-tips which display brief information when rolling cursor over issue lines of the timeline,

because currently those kind of tool-tips in gantt aren't designed to spawn on the left, right, below or over the issue lines, depending on which side a

free space available, so the tool-tip wouldn't end up half cut outside of the window.

I tested the way new tool-tips are displayed and saw that they actually support that kind of smart behavior.
gantttooltip.png 

#15 - 2019-09-07 03:04 - Go MAEDA

Antonio McDeal wrote:

I think tool-tips like these should also be used as gantt tool-tips which display brief information when rolling cursor over issue lines of the timeline,

because currently those kind of tool-tips in gantt aren't designed to spawn on the left, right, below or over the issue lines, depending on which

side a free space available, so the tool-tip wouldn't end up half cut outside of the window.

I tested the way new tool-tips are displayed and saw that they actually support that kind of smart behavior.
 It is a big change to discuss on this issue. Could you open a new issue?

#16 - 2019-09-07 23:16 - Anonymous

Go MAEDA wrote:

Could you open a new issue?

 Of course, I will do now. Could you please add this ticket as related if a relationship would make sense? I don't have a patch at the moment, but if

nobody minds I might try to compose something a tad bit later next week. So far I figured out that jQuery tool-tips should support bare HTML fed into

the title fields of tags (I'm aware of possible XSS but there is a good workaround I should test). Then there is multiple things from old tool-tips to

consider for cleanup, including in style sheets, which shalt not be overlooked.

#17 - 2019-09-08 01:55 - Go MAEDA

- Related to Feature #32029: Replace gantt and calendar tooltips with jquery tooltips added

#18 - 2019-09-09 21:39 - Marius BĂLTEANU

- Status changed from Reopened to Closed

Go MAEDA wrote:

Marius BALTEANU wrote:

Go Maeda, is it better if we remove the title the from gantt issue subject?

 I agree.

But I would like to suggest another option. How about setting "Assignee (Status)" instead of removing the subject? The assignee and status are

important information but those are not prominent in gantt.

Marius, which do you prefer?

 I'll open a new issue to discuss this change (I should have done it from the beginning).

#19 - 2020-01-16 04:49 - Anonymous

When adding some (self made) plugins that use Highcharts graphs, etc., there is no "tooltip" in the "title" attribute.

So,

if ($('[title]').tooltip !== undefined) {

is necessary before calling the tooltip() function.

#20 - 2020-04-04 08:30 - Go MAEDA

- Related to Defect #33250: Useless white box appears over the the tooltip in EdgeHTML added

#21 - 2021-01-19 09:59 - Go MAEDA

- Related to Defect #34247: Web browser freezes when displaying workflow page with a large number of issue statuses added

#22 - 2021-03-04 08:01 - Go MAEDA

- Related to Defect #34834: Line breaks in the description of a custom field are ignored in a tooltip added
